/*!
* @file Authority.h
* @brief 権能のプロトタイプ宣言
* @date 2013/12/22
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"
#include "CreatureTemplate.h"

namespace Deeangband
{

	/*! 
	* @class Authority
	* @brief 権能のクラス
	*/
	class Authority : public CreatureTemplate
	{
	private:

		NAME name; //!< 権能の名前

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param fileVersion ファイルバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int fileVersion) 
		{
			archive & BOOST_SERIALIZATION_NVP(name);
		}

	public:

		/*! 
		* @brief Authorityクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		Authority::Authority(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief Authorityクラスコンストラクタ
		*/
		Authority::Authority(void);

		/*! 
		* @brief Authorityクラスデストラクタ
		*/
		Authority::~Authority(void);

		/*! 
		* @brief 権能名を返す
		* @return 権能名
		*/
		NAME Authority::GetName(void);
	};

}